#include<iostream>
using namespace std;
long long prodbonacci(long long n,long long a,long long b){
    a=a%1000;
    b=b%1000;
   unsigned long long z=a*b;
   int ed=z%10;
   int des=(z%100)/10;
   int st=(z%1000)/100;
   if(ed!=0){
     ed--;
   }else{
      ed=9;
   }

   if(des!=0){
     des--;
   }else{
      des=9;
   }

   if(st!=0){
     st--;
   }else{
      st=9;
   }
   if(a*b>=100){
     return st*100+des*10+ed;
   }
   if(a*b<100 && a*b>=10){
     return des*10+ed;
   }
  return ed;
}
int main(){
 unsigned long long a,b,n,p,staro1,staro2;
 cin>>n>>a>>b;
 staro1=a;
 staro2=b;
 if(n==2){
    cout<<b;
    return 0;
 }
 if(n==1){
    cout<<a;
    return 0;
 }
 for(long long i=2 ; i<n ; i++){
        //cout<<"a";
    p=prodbonacci(i,staro1,staro2);
    staro1=staro2;
    staro2=p;
 }
 cout<<p;
 return 0;
}
